#!/bin/bash

##################################################################
# 22.04.2017 - потерян предыдущий проект - начато почти с нуля
#              добавлена опция по умолчанию
##################################################################


date="22.04.2017"
vers="01.03"
echo ""
echo "----- configuration project($vers) $date ------"

inpath="src"
outpath="work"
omake="work/Makefile"
outscript=""
ih="src/*.h"
ic="src/*.c"
icpp="src/*.cpp"
oh="work"
oc="work"
ocpp="work"
#входной параметр
p1=$1
#
NAME=""
#
FCLIENT="0"	#клиент
FMAIN="0"	#наличие процесса main (самостоятельная программа)
FCAM="0"	#функция камеры
FMOTORS="0"	#функция приводов
FDBG="0"	#консольная отладка


function _help()
{
  echo ""
  echo "--help    - current screen info"
  echo ""
  echo "--main    - main configuratin"
  echo "            server  = 1"
  echo "            motors  = 1"
  echo "            webcam  = 1"
  echo ""
  echo "-ic       - interactive config"
  echo ""
}

#Генерация Makefile
function _CreateMakefile()
{
  # Шаблон Makefile
  echo ""
  echo "############################################"
  echo "# Makefile Version: $vers   Date: $date"
  echo "############################################"
  echo ""
  #
  echo "############################################" > $omake
  echo "# Makefile Version: $vers   Date: $date" >> $omake
  echo "############################################" >> $omake
  echo "" >> $omake
  echo "#compilators" >> $omake
  echo "CPP		:= g++" >> $omake
  echo "CC		:= gcc" >> $omake
  echo "#" >> $omake
  echo "CFLAGS          := -c -Wall" >> $omake
  # Запросы для Makefile
  echo "interactive config:"
  echo "Name Project:"
  read NAME
  echo "NAME		:= $NAME" >> $omake
  echo "Using OpenCV:(1/0)"
  read p1
  if(($p1 > 0))
   then
    echo "INCL		:= -I/usr/local/include/opencv" >> $omake
    echo "LIB		:= -L/usr/local/lib" >> $omake
    echo "CPPLIBRARIES	:= -lopencv_core -lopencv_imgproc -lopencv_highgui -lpthread" >> $omake
   else
    echo "INCL		:=" >> $omake
    echo "LIB		:=" >> $omake
    echo "CPPLIBRARIES	:= -lpthread" >> $omake
  fi
  #Правила
  echo "SRC		:= \$(shell ls *.cpp)" >> $omake
  echo "OBJ		:= \$(SRC: .cpp=.o)" >> $omake
  echo "all:	\$(NAME)" >> $omake
  echo "" >> $omake
  echo "\$(NAME):	\$(OBJ)" >> $omake
  echo "	\$(CPP) \$(LIB) \$(CPPLIBRARIES) \$(OBJ) -o \$(NAME)" >> $omake
  echo "" >> $omake
  echo "\$(OBJ):	\$(SRC)" >> $omake
  echo "	\$(CPP) -c \$(SRC)" >> $omake
  echo "" >> $omake
  echo "clean:" >> $omake
  echo "	rm -f *.o \$(NAME)" >> $omake
}

#конфигурация проекта
function _Config()
{
  echo ""
  echo "############################################"
  echo "#           Configutate Proeсt             #"
  echo "############################################"
  echo ""
  #вывод в консоль отладки
  if( ((FDBG == 1)) )
   then
    sed -i '/#define _mode_dbg/s/0/1/g' $outpath/config.h
    echo "Debug message: $FDBG"
  fi
  #режим клиента
  if( ((FCLIENT == 1)) )
   then
    sed -i '/#define _mode_client/s/0/1/g' $outpath/config.h
    echo "Client mode: $FCLIENT"
  fi
  #web-камера
  if( ((FCAM == 1)) )
   then
    sed -i '/#define _func_cam/s/0/1/g' $outpath/config.h
    echo "Web Camera: $FCAM"
  fi
  #приводы
  if( ((FMOTORS == 1)) )
   then
    sed -i '/#define _func_motors/s/0/1/g' $outpath/config.h
    echo "Motorc control: $FMOTORS"
  fi
}

#генерайия скрипта
function _CreateScript()
{
  if( ((FMAIN > 0)) )
   then 
   echo ""
   echo "##############################################"
   echo "# Creating Strt Script"
   echo "##############################################"
   echo ""
   #
   echo "Name for Start. Script of BASH"
   read outscript
   echo "#!/bin/bash" > $outpath/$outscript
   echo "#" >> $outpath/$outscript
   if( ((FCLIENT > 0)) )
    then
     echo "IP addr (smple: 192.168.0.1)"
     read ip
     echo "IP port for $ip"
     read ipp
     echo "./$NAME $ip $ipp" >> $outpath/$outscript
     echo "./$NAME $ip $ipp"
   else
     echo "IP port for listen"
     read ipp
     echo "./$NAME -p $ipp" >> $outpath/$outscript
     echo "./$NAME -p $ipp"
   fi
   #запуск для скрипта
   chmod +x $outpath/$outscript
  fi
}


#interactive config
function _ic()
{
  #cp $ih $oh
  #cp $ic $oc
  #cp $icpp $ocpp
  #копирование обязательных файлов
  cp $inpath/tdef.h $outpath/tdef.h
  cp $inpath/config.h $outpath/config.h
  cp $inpath/id.h $outpath/id.h
  cp $inpath/id.cpp $outpath/id.cpp
  cp $inpath/vcsocket.h $outpath/vcsocket.h
  cp $inpath/vcsocket.cpp $outpath/vcsocket.cpp
  #main
  echo "use main function ( 1-main / 0-for extern )"
  read p1
  if(($p1 > 0))
   then
    cp $inpath/main.h $outpath/main.h
    cp $inpath/main.cpp $outpath/main.cpp
    FMAIN="1"
  else
    FMAIN="0"
  fi
  #веб kamepa
  echo "use wem cam ( 1-web cam / 0-No cam )"
  read p1
  if(($p1 > 0))
   then
    FCAM="1"
    cp $inpath/wcam.h $outpath/wcam.h
    cp $inpath/wcam.cpp $outpath/wcam.cpp
  else
   FCAM="0"
  fi
  #Motors
  echo "use local Motors ( 1-Morors / 0-No Motors )"
  read p1
  if(($p1 > 0))
   then
    FMOTORS="1"
    cp $inpath/motors.h $outpath/motors.h
    cp $inpath/motors.cpp $outpath/motors.cpp
  else
    FMOTORS="0"
  fi
  #ModbusRTU
  echo "use local Modbus RTU ( 1-Local Modbus RTU / 0-No Local Modbus RTU)"
  read p1
  if(($p1 > 0))
   then
    FMRTU="1"
    cp $inpath/mrtu.h $outpath/mrtu.h
    cp $inpath/mrtu.cpp $outpath/mrtu.cpp
  else
    FMRTU="0"
  fi
  #режим отладки
  echo "debug mode (use debug to console) ( 1-Message to console / 0-No message )"
  read p1
  if(($p1 > 0))
   then
    FDBG="1"
  else
    FDBG="0"
  fi
  #режми клиента
  echo "client or server ( 1-client / 0-server )"
  read p1
  if(($p1 > 0))
   then
    FCLIENT="1"
  else
    FCLIENT="0"
  fi
  #коррекция конфигурации в файле config.h
  _Config
  ############
  if(($FMAIN < 1))
   then
    return
  fi
  #формирование Makefile
  _CreateMakefile
  #формирование скрипта запуска
  _CreateScript
}

#моя конфигурация по умолчанию
function _main_def()
{
	FCLIENT="0"	#клиент
	FMAIN="1"	#наличие процесса main (самостоятельная программа)
	FCAM="1"	#функция камеры
	FMOTORS="1"	#функция приводов
	FDBG="0"	#консольная отладка
	#копирование обязательных файлов
  	cp $inpath/tdef.h $outpath/tdef.h
  	cp $inpath/config.h $outpath/config.h
  	cp $inpath/id.h $outpath/id.h
  	cp $inpath/id.cpp $outpath/id.cpp
  	cp $inpath/vcsocket.h $outpath/vcsocket.h
  	cp $inpath/vcsocket.cpp $outpath/vcsocket.cpp
	#
	cp $inpath/main.h $outpath/main.h
    	cp $inpath/main.cpp $outpath/main.cpp
	cp $inpath/wcam.h $outpath/wcam.h
    	cp $inpath/wcam.cpp $outpath/wcam.cpp
	cp $inpath/motors.h $outpath/motors.h
    	cp $inpath/motors.cpp $outpath/motors.cpp
	cp $inpath/mrtu.h $outpath/mrtu.h
    	cp $inpath/mrtu.cpp $outpath/mrtu.cpp
	#коррекция конфигурации в файле config.h
  	_Config
	#формирование Makefile
  	_CreateMakefile
  	#формирование скрипта запуска
  	_CreateScript
}

case $p1 in
  -ic)
   _ic
   ;;
  --help)
   _help
   ;;
  --main)
   _main_def
   ;;
  *)
   echo "\"--help\" for info"
   ;;
esac
